<template>
  <div class="col-sm-12 col-md-12 auth-bg-left ps-4">
    <div class="h-100 ps-5">
      <div class="logo-container p-4">
        <img src="@/assets/img/logo.png" alt="Main Logo" style="height: 50px" />
      </div>
      <div class="form-container mt-4 p-4">
        <div class="row">
          <div class="col-sm-12 col-md-6">
            <div class="form-head d-flex align-items-center">
              <div class="">
                <h2 class="fw-bold">Open an Account</h2>
              </div>
            </div>
            <div class="progress my-4" style="height: 3px">
              <div
                class="progress-bar bg-primary"
                role="progressbar"
                style="width: 45%"
              ></div>
            </div>
          </div>
        </div>
        <div class="row">
          <div class="col-sm-12 col-md-6">
            <div class="form-meta mb-3">
              <h4 class="fw-bold">Personal Info</h4>
              <p>
                You are required to fill this manually if did not provide your
                BVN previously
              </p>
            </div>
          </div>
        </div>
        <form @submit.prevent="submitForm()">
          <div class="row">
            <div class="col-sm-12 col-md-6">
              <div class="form-group">
                <div class="form-input mb-3">
                  <!-- <label for="FirstName">First Name & Other Name</label> -->
                  <input
                    id="formBVN"
                    v-model="form.firstName"
                    v-validate="'required'"
                    type="text"
                    class="form-control"
                    placeholder="First Name & Other Name *"
                    name="First Name & Other Name"
                  />
                  <div
                    v-show="verrors.has('First Name & Other Name')"
                    class="invalid-feedback"
                  >
                    {{ verrors.first('First Name & Other Name') }}
                  </div>
                </div>
              </div>
              <div class="form-group">
                <div class="form-input mb-3">
                  <input
                    id="formSurnName"
                    v-model="form.surnName"
                    v-validate="'required'"
                    type="text"
                    class="form-control"
                    placeholder="Surname *"
                    name="Surname"
                  />
                  <div v-show="verrors.has('Surname')" class="invalid-feedback">
                    {{ verrors.first('Surname') }}
                  </div>
                </div>
              </div>
              <div class="form-group">
                <div class="form-input mb-3">
                  <input
                    id="formPhoneNumber"
                    v-model="form.phoneNumber"
                    v-validate="'required'"
                    type="text"
                    class="form-control"
                    placeholder="Phone Number *"
                    name="Phone Number"
                  />
                  <div
                    v-show="verrors.has('Phone Number')"
                    class="invalid-feedback"
                  >
                    {{ verrors.first('Phone Number') }}
                  </div>
                </div>
              </div>
              <div class="form-group">
                <div class="form-input mb-3">
                  <input
                    id="formDOB"
                    v-model="form.dateofBirth"
                    v-validate="'required'"
                    type="date"
                    class="form-control"
                    placeholder="Date of Birth *"
                    name="Date of Birth"
                  />
                  <div
                    v-show="verrors.has('Date of Birth')"
                    class="invalid-feedback"
                  >
                    {{ verrors.first('Date of Birth') }}
                  </div>
                </div>
              </div>
              <div class="form-group">
                <div class="form-input mb-3">
                  <select
                    id="formGender"
                    v-model="form.gender"
                    v-validate="'required'"
                    name="Gender"
                    placeholder="Gender *"
                    class="form w-100"
                  >
                    <option :value="null">Gender</option>
                    <option value="male">Male</option>
                    <option value="female">Female</option>
                  </select>

                  <div v-show="verrors.has('Gender')" class="invalid-feedback">
                    {{ verrors.first('Gender') }}
                  </div>
                </div>
              </div>
            </div>
            <div class="col-sm-12 col-md-6">
              <div class="form-group">
                <div class="form-input mb-3">
                  <input
                    id="formEmailAddress"
                    v-model="form.email"
                    v-validate="'required|email'"
                    type="text"
                    class="form-control"
                    placeholder="Email Address"
                    name="Email Address"
                  />
                  <div
                    v-show="verrors.has('Email Address')"
                    class="invalid-feedback"
                  >
                    {{ verrors.first('Email Address') }}
                  </div>
                </div>
              </div>
              <div class="form-group">
                <div class="form-input mb-3">
                  <input
                    id="formOccupation"
                    v-model="form.occupation"
                    v-validate="'required'"
                    type="text"
                    class="form-control"
                    placeholder="Occupation *"
                    name="Occupation"
                  />
                  <div
                    v-show="verrors.has('Occupation')"
                    class="invalid-feedback"
                  >
                    {{ verrors.first('Occupation') }}
                  </div>
                </div>
              </div>
              <div class="form-group">
                <div class="form-input mb-3">
                  <input
                    id="formResidentialAddress"
                    v-model="form.residentialAddress"
                    v-validate="'required'"
                    type="text"
                    class="form-control"
                    placeholder="Residential Address *"
                    name="Residential Address"
                  />
                  <div
                    v-show="verrors.has('Residential Address')"
                    class="invalid-feedback"
                  >
                    {{ verrors.first('Residential Address') }}
                  </div>
                </div>
              </div>
              <div class="form-group">
                <div class="form-input mb-3">
                  <select
                    id="formState"
                    v-model="form.state"
                    v-validate="'required'"
                    name="State"
                    placeholder="State"
                    class="form w-100"
                    @change="updateLGA"
                  >
                    <option :value="null">State</option>
                    <option v-if="form.state" :value="form.state">
                      {{ form.state.name }}
                    </option>
                    <option
                      v-for="(state, i) in states"
                      :key="i"
                      :value="state"
                    >
                      {{ state.name }}
                    </option>
                  </select>

                  <div v-show="verrors.has('State')" class="invalid-feedback">
                    {{ verrors.first('State') }}
                  </div>
                </div>
              </div>
              <div class="form-group">
                <div class="form-input mb-3">
                  <select
                    id="formLGA"
                    v-model="form.lga"
                    v-validate="'required'"
                    name="LGA"
                    placeholder="LGA"
                    class="form w-100"
                  >
                    <option :value="null">LGA</option>
                    <option v-if="form.lga" :value="form.lga">
                      {{ form.lga.name }}
                    </option>
                    <option v-for="(lga, i) in lgas" :key="i" :value="lga">
                      {{ lga.name }}
                    </option>
                  </select>

                  <div v-show="verrors.has('LGA')" class="invalid-feedback">
                    {{ verrors.first('LGA') }}
                  </div>
                </div>
              </div>
              <div class="form-group">
                <div class="form-input mb-3">
                  <input
                    id="formCity"
                    v-model="form.city"
                    v-validate="'required'"
                    type="text"
                    class="form-select"
                    placeholder="City"
                    name="City"
                  />
                  <div v-show="verrors.has('City')" class="invalid-feedback">
                    {{ verrors.first('City') }}
                  </div>
                </div>
              </div>
              <div class="mt-3">
                <vs-button type="submit" circle block :loading="form.active">
                  Next
                </vs-button>
              </div>
            </div>
          </div>
        </form>
      </div>
    </div>
  </div>
</template>

<script>
export default {
  layout: 'open-account-layout',
  middleware: 'auth-pages',
  async asyncData({ $axios }) {
    const { data } = await $axios.get('/miscellaneous/states')
    // console.log(stateResponse)
    return {
      states: data.payload,
    }
  },
  data: () => ({
    lgas: [],
    form: {
      active: false,
      loading: false,
      gender: null,
      state: null,
      lga: null,
    },
  }),
  created() {
    this.form = {
      ...this.form,
      ...this.$store.getters['auth/authDetails'],
    }
  },
  methods: {
    async updateLGA() {
      if (this.form.state) {
        this.form.lga = null
        this.form.active = true
        this.lgas = []

        const response = await this.$axios.$get(
          `/miscellaneous/${this.form.state.id}/lga`
        )
        // console.log(this.form.state, response)
        this.lgas = response.payload
        this.form.active = false
      }
    },
    submitForm() {
      // console.log(this.form)
      this.$validator.validateAll().then((result) => {
        if (result) {
          // eslint-disable-next-line
          this.$store.commit('auth/UPDATE_AUTH_DATA', this.form)
          this.$router.push('/auth/open-account/password')
        }
      })
    },
  },
}
</script>

<style lang="scss">
@import '~@/assets/scss/index';
@import '~@/assets/scss/variables';
</style>
